Ruby: pm_index_and_write_node Struct Reference

Ruby 3.4.7p58 (2025-10-08 revision 7a5688e2a27668e48f8d6ff4af5b2208b98a2f5e)

Data Fields
pm_index_and_write_node Struct Reference

IndexAndWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | receiver
| IndexAndWriteNode#receiver.
pm_location_t | call_operator_loc
| IndexAndWriteNode#call_operator_loc.
pm_location_t | opening_loc
| IndexAndWriteNode#opening_loc.
struct pm_arguments_node * | arguments
| IndexAndWriteNode#arguments.
pm_location_t | closing_loc
| IndexAndWriteNode#closing_loc.
struct pm_block_argument_node * | block
| IndexAndWriteNode#block.
pm_location_t | operator_loc
| IndexAndWriteNode#operator_loc.
struct pm_node * | value
| IndexAndWriteNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

IndexAndWriteNode.

Represents the use of the &&= operator on a call to the [] method.

    foo.bar[baz] &&= value
    ^^^^^^^^^^^^^^^^^^^^^^

Type: ::PM_INDEX_AND_WRITE_NODE

Flags (#pm_call_node_flags):

- ::PM_CALL_NODE_FLAGS_SAFE_NAVIGATION
- ::PM_CALL_NODE_FLAGS_VARIABLE_CALL
- ::PM_CALL_NODE_FLAGS_ATTRIBUTE_WRITE
- ::PM_CALL_NODE_FLAGS_IGNORE_VISIBILITY

Definition at line 4725 of file ast.h.

## Field Documentation

## ◆ arguments

struct pm_arguments_node* pm_index_and_write_node::arguments

IndexAndWriteNode#arguments.

Definition at line 4748 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ base

pm_node_t pm_index_and_write_node::base

The embedded base node.

Definition at line 4727 of file ast.h.

Referenced by pm_dump_json().

## ◆ block

struct pm_block_argument_node* pm_index_and_write_node::block

IndexAndWriteNode#block.

Definition at line 4758 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ call_operator_loc

pm_location_t pm_index_and_write_node::call_operator_loc

IndexAndWriteNode#call_operator_loc.

Definition at line 4738 of file ast.h.

Referenced by pm_dump_json().

## ◆ closing_loc

pm_location_t pm_index_and_write_node::closing_loc

IndexAndWriteNode#closing_loc.

Definition at line 4753 of file ast.h.

Referenced by pm_dump_json().

## ◆ opening_loc

pm_location_t pm_index_and_write_node::opening_loc

IndexAndWriteNode#opening_loc.

Definition at line 4743 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_index_and_write_node::operator_loc

IndexAndWriteNode#operator_loc.

Definition at line 4763 of file ast.h.

Referenced by pm_dump_json().

## ◆ receiver

struct pm_node* pm_index_and_write_node::receiver

IndexAndWriteNode#receiver.

Definition at line 4733 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ value

struct pm_node* pm_index_and_write_node::value

IndexAndWriteNode#value.

Definition at line 4768 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h